<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
            <!--            <el-form-item label="一级分类名称" prop="pid" label-width="100px">-->
            <!--                <el-select v-model="queryParams.pid" filterable clearable placeholder="请输入一级分类分类名称">-->
            <!--                    <el-option-->
            <!--                        v-for="option in options"-->
            <!--                        :key="option.suppliesName"-->
            <!--                        :label="option.suppliesName"-->
            <!--                        :value="option.id"-->
            <!--                    ></el-option>-->
            <!--                    <el-option label="无" value="0"></el-option>-->
            <!--                </el-select>-->
            <!--            </el-form-item>-->
            <el-form-item label="一级分类名称" prop="suppliesName" label-width="100px">
                <el-input
                    v-model="queryParams.suppliesName"
                    placeholder="请输入一级分类名称"
                    clearable
                    size="small"
                    @keyup.enter.native="handleQuery"
                    maxlength="36"
                />
            </el-form-item>
            <el-form-item label="状态" prop="status">
                <el-select v-model="queryParams.status" placeholder="请选择状态" clearable @keyup.enter.native="handleQuery">
                    <el-option label="启用" :value="0"></el-option>
                    <el-option label="禁用" :value="1"></el-option>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button
                    type="primary"
                    plain
                    icon="el-icon-plus"
                    size="mini"
                    @click="handleAdd"
                    v-hasPermi="['supplies:supplies:add']"
                >新增一级分类</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button
                    type="success"
                    plain
                    icon="el-icon-edit"
                    size="mini"
                    :disabled="single"
                    @click="handleUpdate"
                    v-hasPermi="['supplies:supplies:edit']"
                >修改</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button
                    type="danger"
                    plain
                    icon="el-icon-delete"
                    size="mini"
                    :disabled="multiple"
                    @click="handleDelete"
                    v-hasPermi="['supplies:supplies:remove']"
                >删除</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button
                    type="warning"
                    plain
                    icon="el-icon-download"
                    size="mini"
                    @click="handleExport"
                    v-hasPermi="['supplies:supplies:export']"
                >导出</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="suppliesList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
            <!--      <el-table-column label="ID" align="center" prop="id" />-->
            <el-table-column type="index" width="80" align="center" label="序号" :index="indexMethod" />
            <el-table-column label="一级分类名称" align="center" prop="suppliesName"  maxlength="36"/>
            <el-table-column label="状态" align="center">
                <template slot-scope="scope">
                    <div>
                        <el-switch
                            @change="toggleEnable(scope.row)"
                            v-model="scope.row.status"
                            :active-value="0"
                            :inactive-value="1"
                            active-color="#13ce66"
                            inactive-color="#cccccc">
                        </el-switch>
                    </div>
                </template>
            </el-table-column>
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                <template slot-scope="scope">
                    <el-button
                        size="mini"
                        type="text"
                        icon="el-icon-edit"
                        @click="handleUpdate(scope.row)"
                        v-hasPermi="['supplies:supplies:edit']"
                    >修改</el-button>
                    <el-button
                        size="mini"
                        type="text"
                        icon="el-icon-delete"
                        @click="handleDelete(scope.row)"
                        v-hasPermi="['supplies:supplies:remove']"
                    >删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <pagination
            v-show="total>0"
            :total="total"
            :page.sync="queryParams.pageNum"
            :limit.sync="queryParams.pageSize"
            @pagination="getList"
        />
        <!-- 添加或修改物料总分类管理对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
            <el-form ref="form" :model="form" :rules="rules" label-width="80px">
                <el-form-item label="一级分类名称" prop="suppliesName" >
                    <el-input v-model="form.suppliesName" placeholder="请输入一级分类名称" maxlength="36"/>
                </el-form-item>
                <el-form-item label="状态" prop="status">
                    <el-select v-model="form.status" placeholder="请选择状态">
                        <el-option label="启用" :value="0"></el-option>
                        <el-option label="禁用" :value="1"></el-option>
                    </el-select>
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm">确 定</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>

    </div>
</template>

<script>
import {
    listSupplies,
    toggleEnable,
    toggleDisable,
    getSupplies,
    delSupplies,
    addSupplies,
    updateSupplies,
    exportSupplies,
    getPid,
    listSuppliesOne, exportSuppliesOne
} from "@/api/Actsupplies/Actsupplies";

export default {
    name: "Supplies",
    components: {
    },
    data() {
        let checkId =(rule,value,callback) => {
        };
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            name: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 物料总分类管理表格数据
            suppliesList: [],

            options: [], // 初始化空数组
            selectedOption: '' ,// 选中的选项



            // 弹出层标题
            title: "",

            // 是否显示弹出层
            open: false,
            opentwo: false,
            // 查询参数
            queryParams: {
                id: null,
                pageNum: 1,
                pageSize: 10,
                pid: 0,
                fname:null,
                suppliesName: null,
                orderNum: null,
                status: 0,
            },
            // 表单参数
            form: {},
            // 表单校验
            rules: {
                pid: [
                    { required: true, message: "关联id不能为空", trigger: "change" },
                ],
                suppliesName:[
                    { required: true, message: "物料名称不能为空", trigger: "blur" }
                ],
            },
            idRules:[
                { pattern: /^\d+$/, message: 'ID只能输入数字', trigger: 'blur' }
            ]
        };
    },
    created() {
        this.getList();
    },
    mounted() {
        this.fetchOptions();
    },
    methods: {

        /**显示序号*/
        indexMethod(index){
            // const pageSize = this.queryParams.pageSize;
            // const pageNumber = this.queryParams.pageNum || 1;
            return  index + 1;
        },
        /**启用 */
        toggleEnable(actSupplies){
            console.log('你点击了【' + actSupplies.suppliesName+'】的开关控件，当前开关值:' + actSupplies.status);
            let enableText=['启用','禁用'];
            if(actSupplies.status === 0) {
                toggleEnable(actSupplies.id).then((response) =>{
                    if(response.code === 200){
                        let message = '操作成功，已经将【' + actSupplies.suppliesName +'】的状态改为【'+ enableText[actSupplies.status] +'】 !';
                        this.$message({
                            message: message,
                            type:'success'
                        });
                    }else {
                        this.$message.error(response.message);
                    }

                });
            }else {
                toggleDisable(actSupplies.id).then((response) =>{
                    if(response.msg === "200"){
                        let message = '操作成功，已经将【' + actSupplies.suppliesName +'】的状态改为【'+ enableText[actSupplies.status] +'】 !';
                        this.$message({
                            message: message,
                            type:'error'
                        });
                    }else {
                        this.getList();
                        this.$message.error(response.msg);
                    }

                });
            }
        },


        /** 查询上级关联关系*/
        fetchOptions() {
            getPid().then(response => {
                console.log(response.rows)
                this.options = response.rows;
            });
        },

        /** 查询物料总分类管理列表 */
        getList() {
            this.indexMethod(0);
            this.loading = true;
            listSuppliesOne(this.queryParams).then(response => {
                this.suppliesList = response.rows;
                this.total = response.total;
                this.loading = false;
            });
        },
        // 取消按钮
        cancel() {
            this.open = false;
            this.opentwo = false;
            this.reset();
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                pid: 0,
                fname:null,
                suppliesName: null,
                orderNum: null,
                status: 0,
                createBy: null,
                createTime: null,
                updateBy: null,
                updateTime: null
            };
            this.resetForm("form");
        },
        /** 搜索按钮操作 */
        handleQuery() {

            this.queryParams.pageNum = 1;
            if ('最高级'.indexOf(this.queryParams.fname) !== -1){
                this.queryParams.pid = 0;
            }
            this.getList();

        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm("queryForm");
            this.handleQuery();
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map(item => item.id)
            this.name = selection.map(item => item.suppliesName)
            this.single = selection.length!==1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset();
            this.form.pid = 0;
            this.open = true;
            this.title = "新增二级分类";
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset();
            const id = row.id || this.ids
            getSupplies(id).then(response => {
                this.form = response.data;
                this.open = true;
                this.title = "修改物料总分类管理";
            });
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs["form"].validate(valid => {
                if (valid) {
                    if (this.form.id != null) {
                        updateSupplies(this.form).then(response => {
                            this.msgSuccess("修改成功");
                            this.open = false;
                            this.opentwo = false;
                            this.getList();
                        });
                    } else {
                        addSupplies(this.form).then(response => {
                            this.msgSuccess("新增成功");
                            this.open = false;
                            this.opentwo = false;
                            this.getList();
                        });
                    }
                }
            });
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids;
            const name = row.suppliesName  || this.name;
            this.$confirm('是否确认删除物料总分类管理编号为"' + name + '"的数据项?', "警告", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning"
            }).then(function() {
                return delSupplies(ids);
            }).then((result) => {
                if (result.data==="操作失败"){
                    this.getList();
                    this.msgError("删除失败,存在关联关系");
                }else {
                    this.getList();
                    this.msgSuccess("删除成功");
                }
            }).catch(()=>{
            })
        },

        /** 导出按钮操作 */
        handleExport() {
            const queryParams = this.queryParams;
            this.$confirm('是否确认导出所有一级分类数据项?', "警告", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning"
            }).then(function() {
                return exportSuppliesOne(queryParams);
            }).then(response => {
                this.download(response.msg);
            })
        }
    }
};
</script>
